



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Codeforces Round #524 (Div. 2) E. Sonya and Matrix Beauty(字符串哈希，马拉车)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Codeforces Round #524 (Div. 2) E. Sonya and Matrix Beauty(字符串哈希，马拉车)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 12:46:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://codeforces.com/contest/1080/problem/E" rel="external nofollow noreferrer">https://codeforces.com/contest/1080/problem/E</a></p>
<h3>题意</h3>
<p>有一个n*m(&lt;=250)的字符矩阵，对于每个子矩阵的每一行可以任意交换字符的顺序，使得每一行每一列都是一个回文串，问最多有多少个这样的子矩阵</p>
<h3>思路</h3>
<ul><li>首先可以思考如何暴力，枚举四个边界（子矩阵），然后判定一下子矩阵的每一行每一列，这样的复杂度是n<em>m</em>n<em>m</em>n*m</li>
<li>很明显需要找一下规律来优化一下复杂度,
<ol><li>对于每一行来说，最多只能存在一种字母的数量是奇数，这样一定可以保证这一行是回文串</li>
<li>对于每一列来说，因为不能交换顺序，所以必须具有回文性质（关于中心点对称），这就需要要求每一行相同的字母数量应该相同</li></ol></li>
<li>根据第二个规律，因为只需要验证每一行是否相同，所以可以采用字符串hash每一行，O(n*m)处理，O(1)验证</li>
<li>首先枚举列的两个端点 O(m<em>m),然后o(n)找出所有连续的回文行，跑马拉车算法，求出连续的回文行中所有的回文子行，O(n),总复杂度O(m</em>m*n)</li>
<li><strong>符合回文性质的都可以用马拉车求出最长回文字串，回文字串个数</strong></li></ul>
<pre class="prettyprint linenums"><code>#include&lt;bits/stdc++.h&gt;<br />
#define ll long long<br />
#define M 605<br />
#define key 233<br />
#define P 1000000007<br />
using namespace std;<br />
int n,m,i,j,a[M][M],c1,c2,l1,l2,msk[M],cnt[M][30],x,ans=0,d1[M],d2[M];<br />
char s[M];<br />
ll hs[M],p[M],tp[M];

int ck(int x){<br />
    return (x==0)||((x&amp;(x-1))==0);<br />
}<br />
void init(){<br />
    p[0]=1;for(int i=1;i&lt;=30;i++)p[i]=p[i-1]*key%P;<br />
}

int cal(int l1,int l2){<br />
    int n=0,ans=0;<br />
    for(int i=l1;i&lt;=l2;i++)tp[++n]=hs[i];<br />
    int l=0,r=0,x;<br />
    for(int i=1;i&lt;=n;i++){<br />
        if(i&gt;r)x=1;<br />
        else x=min(d1[l+r-i],r-i);<br />
        while(i-x&gt;=1&amp;&amp;i+x&lt;=n&amp;&amp;tp[i-x]==tp[i+x])x++;<br />
        d1[i]=x;<br />
        ans+=d1[i];<br />
        if(i+x-1&gt;r){r=i+x-1;l=i-x+1;}<br />
    }<br />
    l=r=0;<br />
    for(int i=1;i&lt;=n;i++){<br />
        if(i&gt;r)x=0;<br />
        else x=min(d2[l+r-i+1],r-i+1);<br />
        while(i-x-1&gt;=1&amp;&amp;i+x&lt;=n&amp;&amp;tp[i-x-1]==tp[i+x])x++;<br />
        d2[i]=x;<br />
        ans+=d2[i];<br />
        if(i+x&gt;=r){l=i-x;r=i+x-1;}<br />
    }<br />
    return ans;<br />
}<br />
int main(){<br />
    init();<br />
    cin&gt;&gt;n&gt;&gt;m;<br />
    for(i=1;i&lt;=n;i++){<br />
        scanf(&quot;%s&quot;,s+1);<br />
        for(j=1;j&lt;=m;j++){<br />
            a[i][j]=s[j]-'a';<br />
        }<br />
    }<br />
    for(c1=1;c1&lt;=m;c1++){<br />
        for(i=1;i&lt;=n;i++){<br />
           hs[i]=0;msk[i]=0;<br />
           memset(cnt[i],0,sizeof(cnt[i]));<br />
        }<br />
        for(c2=c1;c2&lt;=m;c2++){<br />
           for(i=1;i&lt;=n;i++){<br />
              x=a[i][c2];<br />
              if(cnt[i][x]){<br />
                 hs[i]-=cnt[i][x]*p[x+1]%P;<br />
                 if(hs[i]&lt;0)hs[i]+=P;<br />
              }<br />
              cnt[i][x]++;<br />
              hs[i]+=cnt[i][x]*p[x+1]%P;hs[i]%=P;<br />
              msk[i]^=(1&lt;&lt;x);<br />
           }<br />
           l1=1;<br />
           while(l1&lt;=n){<br />
             if(!ck(msk[l1])){l1++;continue;}<br />
             l2=l1;<br />
             while(l2&lt;=n&amp;&amp;ck(msk[l2]))l2++;<br />
             l2--;<br />
             ans+=cal(l1,l2);<br />
             l1=l2+1;<br />
           }<br />
        }<br />
    }<br />
    cout&lt;&lt;ans;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q220yvq.html">CEPH经常出现slow request的排查解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4k1p09.html">fastdfs 安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/390x2w39.html">1017作业：配置java环境，学习流程图</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9323g0q.html">C&num;面向对象学习笔记概要</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1e45x9.html">java反射机制简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlme73e9.html">以雅酷网为实例从技术上说说dedecms的seo优化要注意哪些？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1o048.html">C&num; 创建iis站点以及IIS站点属性&comma;iis不能启动站点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm72v19.html">64位linux安装android sdk的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnj23j8.html">模板引擎 Velocity</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okp2619.html">Microsoft SQL Server 管理 （常用管理及维护命令）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y01geq.html">XP 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdd45y9.html">AngularJS 实现按需异步加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlleoveq.html">Redhat乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwvxd9.html">js 数组去重复两种方法一看就懂</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv207dx9.html">C&plus;&plus; 使用LockWorkStation&lpar;&rpar;的过程遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7520q.html">（6）学习笔记 ） ASP&period;NET CORE微服务 Micro-Service ---- AOP框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj6pw59.html">Unity报错 ： BCE0004&colon; Ambiguous reference &amp;&num;39&semi;preview&amp;&num;39&semi;&colon; CameraMotionBlurEditor&period;preview&comma; UnityEditor&period;Editor&period;preview&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjwp659.html">option&lowbar;match</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnmypjq.html">php 操作时间、日期类函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpg3k79.html">bolg迁移</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwv1ylr8.html">jquery--blur&lpar;&rpar;事件，在页面加载时自动获取焦点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyymjygq.html">xadmin系列之启动、注册、分发</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4nloz9.html">apache jmeter 压力测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zydnxd9.html">python脚本linux上后台执行</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllg340q.html">select-options and range</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jrve0q.html">20165315 实验一 Java开发环境的熟悉</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdp3lv9.html">webpack&lpar;一） 安装使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ozroq.html">如何将python中的List转化成dictionary</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv12zz8.html">线特征---LBD算法（三）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rzz7j9.html">Navicat premiu的导入和导出</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
